



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【hive】——Hive sql语法详解</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【hive】——Hive sql语法详解</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-26 03:25:13 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>Hive 是基于Hadoop 构建的一套数据仓库分析系统，它提供了丰富的SQL查询方式来分析存储在Hadoop 分布式文件系统中的数据，可以将结构</p>
<p>化的数据文件映射为一张数据库表，并提供完整的SQL查询功能，可以将SQL语句转换为MapReduce任务进行运行，通过自己的SQL 去查询分析需</p>
<p>要的内容，这套SQL 简称Hive SQL，使不熟悉mapreduce 的用户很方便的利用SQL 语言查询，汇总，分析数据。而mapreduce开发人员可以把</p>
<p>己写的mapper 和reducer 作为插件来支持Hive 做更复杂的数据分析。</p>
<p>它与关系型数据库的SQL 略有不同，但支持了绝大多数的语句如DDL、DML 以及常见的聚合函数、连接查询、条件查询。HIVE不适合用于联机</p>
<p>online)事务处理，也不提供实时查询功能。它最适合应用在基于大量不可变数据的批处理作业。</p>
<p>HIVE的特点：可伸缩（在Hadoop的集群上动态的添加设备），可扩展，容错，输入格式的松散耦合。</p>
<p>Hive 的官方文档中对查询语言有了很详细的描述，请参考：http://wiki.apache.org/hadoop/Hive/LanguageManual ，本文的内容大部分翻译自该页面，期间加入了一些在使用过程中需要注意到的事项。</p>
<p>1. &nbsp;DDL 操作</p>
<div>
<div>DDL</div>
</div>
<div>
<div>
<div>&bull;建表</div>
<div>&bull;删除表</div>
<div>&bull;修改表结构</div>
<div>&bull;创建／删除视图</div>
<div>&bull;创建数据库</div>
<div>&bull;显示命令</div>
</div>
</div>
<h3>建表：</h3>
<div>
<div>CREATE [EXTERNAL] TABLE [IF NOT EXISTS] table_name&nbsp;<br />&nbsp; [(col_name data_type [COMMENT col_comment], ...)]&nbsp;<br />&nbsp; [COMMENT table_comment]&nbsp;<br />&nbsp; [PARTITIONED BY (col_name data_type [COMMENT col_comment], ...)]&nbsp;<br />&nbsp; [CLUSTERED BY (col_name, col_name, ...)&nbsp;<br />&nbsp; [SORTED BY (col_name [ASC|DESC], ...)] INTO num_buckets BUCKETS]&nbsp;<br />&nbsp; [ROW FORMAT row_format]&nbsp;<br />&nbsp; [STORED AS file_format]&nbsp;<br />&nbsp; [LOCATION hdfs_path]</div>
<div>
<div>
<div>&bull;CREATE TABLE 创建一个指定名字的表。如果相同名字的表已经存在，则抛出异常；用户可以用 IF NOT EXIST 选项来忽略这个异常</div>
<div>&bull;EXTERNAL 关键字可以让用户创建一个外部表，在建表的同时指定一个指向实际数据的路径（LOCATION）</div>
<div>&bull;LIKE 允许用户复制现有的表结构，但是不复制数据</div>
<div>&bull;COMMENT可以为表与字段增加描述</div>
<div>&nbsp;</div>
<div>
<div>
<div>&bull;ROW FORMAT</div>
<div>&nbsp;&nbsp;&nbsp; DELIMITED [FIELDS TERMINATED BY char] [COLLECTION ITEMS TERMINATED BY char]</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; [MAP KEYS TERMINATED BY char] [LINES TERMINATED BY char]</div>
<div>&nbsp;&nbsp; | SERDE serde_name [WITH SERDEPROPERTIES (property_name=property_value, property_name=property_value, ...)]</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 用户在建表的时候可以自定义 SerDe 或者使用自带的 SerDe。如果没有指定 ROW FORMAT 或者 ROW FORMAT DELIMITED，将会使用自带的 SerDe。在建表的时候，用户还需要为表指定列，用户在指定表的列的同时也会指定自定义的 SerDe，Hive 通过 SerDe 确定表的具体的列的数据。</div>
<div>
<div>
<div>&bull;STORED AS</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; SEQUENCEFILE</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; | TEXTFILE</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; | RCFILE&nbsp;&nbsp;&nbsp;&nbsp;</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; | INPUTFORMAT input_format_classname OUTPUTFORMAT&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; output_format_classname</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 如果文件数据是纯文本，可以使用 STORED AS TEXTFILE。如果数据需要压缩，使用 STORED AS SEQUENCE 。</div>
</div>
</div>
</div>
</div>
</div>
</div>
</div>
<h3>创建简单表：</h3>
<p>hive&gt; CREATE TABLE pokes (foo INT, bar STRING);</p>
<h3><strong>创建外部表：</strong></h3>
<div>
<div>
<div>CREATE EXTERNAL TABLE page_view(viewTime INT, userid BIGINT,</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp; page_url STRING, referrer_url STRING,</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp; ip STRING COMMENT 'IP Address of the User',</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp; country STRING COMMENT 'country of origination')</div>
<div>&nbsp;COMMENT 'This is the staging page view table'</div>
<div>&nbsp;ROW FORMAT DELIMITED FIELDS TERMINATED BY '\054'</div>
<div>&nbsp;STORED AS TEXTFILE</div>
<div>&nbsp;LOCATION '&lt;hdfs_location&gt;';</div>
<div>
<h3>建分区表</h3>
<div>
<div>
<div>CREATE TABLE par_table(viewTime INT, userid BIGINT,</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp; page_url STRING, referrer_url STRING,</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp; ip STRING COMMENT 'IP Address of the User')</div>
<div>&nbsp;COMMENT 'This is the page view table'</div>
<div>&nbsp;PARTITIONED BY(date STRING, pos STRING)</div>
<div>ROW FORMAT DELIMITED &lsquo;\t&rsquo;</div>
<div>&nbsp;&nbsp; FIELDS TERMINATED BY '\n'</div>
<div>STORED AS SEQUENCEFILE;</div>
<div>
<h3>建Bucket表</h3>
<div>
<div>
<div>CREATE TABLE par_table(viewTime INT, userid BIGINT,</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp; page_url STRING, referrer_url STRING,</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp; ip STRING COMMENT 'IP Address of the User')</div>
<div>&nbsp;COMMENT 'This is the page view table'</div>
<div>&nbsp;PARTITIONED BY(date STRING, pos STRING)</div>
<div>&nbsp;CLUSTERED BY(userid) SORTED BY(viewTime) INTO 32 BUCKETS</div>
<div>&nbsp;ROW FORMAT DELIMITED &lsquo;\t&rsquo;</div>
<div>&nbsp;&nbsp; FIELDS TERMINATED BY '\n'</div>
<div>STORED AS SEQUENCEFILE;</div>
</div>
</div>
</div>
</div>
</div>
</div>
</div>
</div>

<h3>创建表并创建索引字段ds</h3>
<p>hive&gt; CREATE TABLE invites (foo INT, bar STRING) PARTITIONED BY (ds STRING);</p>
<h3>复制一个空表</h3>
<div>
<div>CREATE TABLE empty_key_value_store</div>
<div>LIKE key_value_store;</div>
</div>

<p><strong>例子</strong></p>
<p>create table &nbsp;user_info (user_id int, cid string, ckid string, username string)</p>
<p>row format delimited</p>
<p>fields terminated by '\t'</p>
<p>lines terminated by '\n';</p>
<p>导入数据表的数据格式是：字段之间是tab键分割，行之间是断行。</p>
<p>及要我们的文件内容格式：</p>
<p>100636 &nbsp;100890 &nbsp;c5c86f4cddc15eb7 &nbsp; &nbsp; &nbsp; &nbsp;yyyvybtvt<br />100612 &nbsp;100865 &nbsp;97cc70d411c18b6f &nbsp; &nbsp; &nbsp; &nbsp;gyvcycy<br />100078 &nbsp;100087 &nbsp;ecd6026a15ffddf5 &nbsp; &nbsp; &nbsp; &nbsp;qa000100</p>
<h3>显示所有表：</h3>
<p>hive&gt; SHOW TABLES;</p>
<h3>按正条件（正则表达式）显示表，</h3>
<p>hive&gt; SHOW TABLES '.*s';</p>
<h3>修改表结构</h3>
<div>
<div>
<div>&bull;增加分区、删除分区</div>
<div>&bull;重命名表</div>
<div>&bull;修改列的名字、类型、位置、注释</div>
<div>&bull;增加/更新列</div>
<div>&bull;增加表的元数据信息</div>
</div>
</div>

<h3>表添加一列 ：</h3>
<p>hive&gt; ALTER TABLE pokes ADD COLUMNS (new_col INT);</p>
<h3>添加一列并增加列字段注释</h3>
<p>hive&gt; ALTER TABLE invites ADD COLUMNS (new_col2 INT COMMENT 'a comment');</p>
<h3>更改表名：</h3>
<p>hive&gt; ALTER TABLE events RENAME TO 3koobecaf;</p>
<h3>删除列：</h3>
<p>hive&gt; DROP TABLE pokes;</p>
<h3>增加、删除分区</h3>
<div>
<div>&bull;增加</div>
<div>ALTER TABLE table_name ADD [IF NOT EXISTS] partition_spec [ LOCATION 'location1' ] partition_spec [ LOCATION 'location2' ] ...</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; partition_spec:</div>
<div>&nbsp; : PARTITION (partition_col = partition_col_value, partition_col = partiton_col_value, ...)</div>
<div>&bull;删除</div>
<div>ALTER TABLE table_name DROP partition_spec, partition_spec,...</div>
<div>
<h3>重命名表</h3>
<div>
<div>&bull;ALTER TABLE table_name RENAME TO new_table_name&nbsp;</div>
<div>
<h3>修改列的名字、类型、位置、注释：</h3>
<div>
<div>
<div>&bull;ALTER TABLE table_name CHANGE [COLUMN] col_old_name col_new_name column_type [COMMENT col_comment] [FIRST|AFTER column_name]</div>
<div>&bull;这个命令可以允许改变列名、数据类型、注释、列位置或者它们的任意组合</div>
<div>
<h3>表添加一列 ：</h3>
<p>hive&gt; ALTER TABLE pokes ADD COLUMNS (new_col INT);</p>
<h3>添加一列并增加列字段注释</h3>
<p>hive&gt; ALTER TABLE invites ADD COLUMNS (new_col2 INT COMMENT 'a comment');</p>
</div>
<div>&nbsp;</div>
<div>
<h3>增加/更新列</h3>
<div>
<div>
<div>&bull;ALTER TABLE table_name ADD|REPLACE COLUMNS (col_name data_type [COMMENT col_comment], ...) &nbsp;</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;</div>
<div>&bull;&nbsp;ADD是代表新增一字段，字段位置在所有列后面(partition列前)</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp; REPLACE则是表示替换表中所有字段。</div>
<div>
<h3>增加表的元数据信息</h3>
<div>
<div>&bull;ALTER TABLE table_name SET TBLPROPERTIES table_properties table_properties:</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; :[property_name = property_value&hellip;..]</div>
<div>&nbsp;</div>
<div>&bull;用户可以用这个命令向表中增加metadata</div>
<div>
<h3>改变表文件格式与组织</h3>
<div>
<div>
<div>&bull;ALTER TABLE table_name SET FILEFORMAT file_format</div>
<div>&bull;ALTER TABLE table_name CLUSTERED BY(userid) SORTED BY(viewTime) INTO num_buckets BUCKETS</div>
<div>&nbsp;</div>
<div>&bull;这个命令修改了表的物理存储属性</div>
</div>
<div>
<h3>创建／删除视图</h3>
<div>
<div>&bull;CREATE VIEW [IF NOT EXISTS] view_name [ (column_name [COMMENT column_comment], ...) ][COMMENT view_comment][TBLPROPERTIES (property_name = property_value, ...)]&nbsp;AS SELECT</div>
<div>&bull;增加视图</div>
<div>&bull;如果没有提供表名，视图列的名字将由定义的SELECT表达式自动生成</div>
<div>&bull;如果修改基本表的属性，视图中不会体现，无效查询将会失败</div>
<div>&bull;视图是只读的，不能用LOAD/INSERT/ALTER</div>
<div>&bull;DROP VIEW view_name</div>
<div>&bull;删除视图</div>
<div>
<h3>创建数据库</h3>
<div>
<div>
<div>&bull;CREATE DATABASE name</div>
<div>
<h3>显示命令</h3>
<div>
<div>&bull;show tables;</div>
<div>&bull;show databases;</div>
<div>&bull;show partitions ;</div>
<div>&bull;show functions</div>
<div>&bull;describe extended table_name dot col_name</div>
</div>
</div>
</div>
</div>
</div>
</div>
</div>
</div>
</div>
</div>
</div>
</div>
</div>
</div>
</div>
</div>
</div>
</div>
</div>
</div>
<p>2. &nbsp;DML 操作:元数据存储</p>
<p>hive不支持用insert语句一条一条的进行插入操作，也不支持update操作。数据是以load的方式加载到建立好的表中。数据一旦导入就不可以修改。</p>
<div>
<div>DML包括：INSERT<a href="http://baike.baidu.com/view/226806.htm" rel="external nofollow noreferrer">插入</a>、UPDATE<a href="http://baike.baidu.com/view/23174.htm" rel="external nofollow noreferrer">更新</a>、DELETE<a href="http://baike.baidu.com/view/14787.htm" rel="external nofollow noreferrer">删除</a></div>
</div>
<div>&bull;向数据表内加载文件</div>
<div>&bull;将查询结果插入到Hive表中</div>
<div>&bull;0.8新特性 insert into</div>
<div>&nbsp;</div>
<h3>向数据表内加载文件</h3>
<div>
<div>&bull;LOAD DATA [LOCAL] INPATH 'filepath' [OVERWRITE] INTO TABLE tablename [PARTITION (partcol1=val1, partcol2=val2 ...)]</div>
<div>&bull;Load 操作只是单纯的复制/移动操作，将数据文件移动到 Hive 表对应的位置。</div>
<div>&bull;filepath</div>
<div>&bull;相对路径，例如：project/data1</div>
<div>&bull;绝对路径，例如： /user/hive/project/data1</div>
<div>&bull;包含模式的完整 URI，例如：hdfs://namenode:9000/user/hive/project/data1</div>
<div>例如：</div>
<div>
<p>hive&gt; LOAD DATA LOCAL INPATH './examples/files/kv1.txt' OVERWRITE INTO TABLE pokes;</p>
</div>
<div>
<h3>加载本地数据，同时给定分区信息</h3>
<div>
<div>&bull;加载的目标可以是一个表或者分区。如果表包含分区，必须指定每一个分区的分区名</div>
<div>&bull;filepath 可以引用一个文件（这种情况下，Hive 会将文件移动到表所对应的目录中）或者是一个目录（在这种情况下，Hive 会将目录中的所有文件移动至表所对应的目录中）</div>
<div>
<div>LOCAL关键字</div>
<div>
<div>&bull;指定了LOCAL，即本地</div>
<div>&bull;load 命令会去查找本地文件系统中的 filepath。如果发现是相对路径，则路径会被解释为相对于当前用户的当前路径。用户也可以为本地文件指定一个完整的 URI，比如：file:///user/hive/project/data1.</div>
<div>&bull;load 命令会将 filepath 中的文件复制到目标文件系统中。目标文件系统由表的位置属性决定。被复制的数据文件移动到表的数据对应的位置</div>
<div>&nbsp;</div>
<div>
<p><strong>例如：加载本地数据，同时给定分区信息：</strong></p>
</div>
<div>hive&gt; LOAD DATA LOCAL INPATH './examples/files/kv2.txt' OVERWRITE INTO TABLE invites PARTITION (ds='2008-08-15');</div>
<div>&nbsp;</div>
<div>&bull;&nbsp;没有指定LOCAL</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 如果 filepath 指向的是一个完整的 URI，hive 会直接使用这个 URI。 否则</div>
<div>&bull;如果没有指定 schema 或者 authority，Hive 会使用在 hadoop 配置文件中定义的 schema 和 authority，fs.default.name 指定了 Namenode 的 URI</div>
<div>&bull;如果路径不是绝对的，Hive 相对于 /user/ 进行解释。 Hive 会将 filepath 中指定的文件内容移动到 table （或者 partition）所指定的路径中</div>
<div></p>
<p><strong>加载DFS数据 ，同时给定分区信息：</strong></p>
<p>hive&gt; LOAD DATA INPATH '/user/myname/kv2.txt' OVERWRITE INTO TABLE invites PARTITION (ds='2008-08-15');<br />The above command will load data from an HDFS file/directory to the table. Note that loading data from HDFS will result in moving the file/directory. As a result, the operation is almost instantaneous.</p>
</div>
<div>&nbsp;</div>
<div>
<h3>OVERWRITE</h3>
<div>
<div>&bull;指定了OVERWRITE</div>
<div>&bull;目标表（或者分区）中的内容（如果有）会被删除，然后再将 filepath 指向的文件/目录中的内容添加到表/分区中。</div>
<div>&nbsp;</div>
<div>&bull;如果目标表（分区）已经有一个文件，并且文件名和 filepath 中的文件名冲突，那么现有的文件会被新文件所替代。</div>
<div>&nbsp;</div>
<div>
<h3>将查询结果插入Hive表</h3>
<div>
<div>&bull;将查询结果插入Hive表</div>
<div>&bull;将查询结果写入HDFS文件系统</div>
<div>
<div>&bull;基本模式</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp; INSERT OVERWRITE TABLE tablename1 [PARTITION (partcol1=val1, partcol2=val2 ...)] select_statement1 FROM from_statement</div>
<div>
<div>&bull;多插入模式</div>
<div>&nbsp;FROM from_statement</div>
<div>INSERT OVERWRITE TABLE tablename1 [PARTITION (partcol1=val1, partcol2=val2 ...)] select_statement1</div>
<div>[INSERT OVERWRITE TABLE tablename2 [PARTITION ...] select_statement2] ...</div>
<div>
<div>&bull;自动分区模式</div>
<div>&nbsp;INSERT OVERWRITE TABLE tablename PARTITION (partcol1[=val1], partcol2[=val2] ...) select_statement FROM from_statement</div>
<div>
<h3>将查询结果写入HDFS文件系统</h3>
<div>
<div>&bull;INSERT OVERWRITE [LOCAL] DIRECTORY directory1 SELECT ... FROM ...</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; FROM from_statement</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; INSERT OVERWRITE [LOCAL] DIRECTORY directory1 select_statement1</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp; [INSERT OVERWRITE [LOCAL] DIRECTORY directory2 select_statement2]</div>
<div>&bull;</div>
<div>&bull;数据写入文件系统时进行文本序列化，且每列用^A 来区分，\n换行</div>
<div>
<h3>INSERT&nbsp;INTO</h3>
<div>
<div>&bull;INSERT INTO&nbsp; TABLE tablename1 [PARTITION (partcol1=val1, partcol2=val2 ...)] select_statement1 FROM from_statement</div>
</div>
</div>
</div>
</div>
</div>
</div>
</div>
</div>
</div>
</div>
</div>
</div>
</div>
</div>
</div>
</div>

<p>3. &nbsp;DQL 操作:数据查询SQL</p>
<div>SQL操作</div>
<div>
<div>&bull;基本的Select 操作</div>
<div>&bull;基于Partition的查询</div>
<div>&bull;Join</div>
</div>
<div>&nbsp;</div>
<h3>3.1 基本的Select&nbsp;操作</h3>
<div>
<div>SELECT [ALL | DISTINCT] select_expr, select_expr, ...</div>
<div>FROM table_reference</div>
<div>[WHERE where_condition]</div>
<div>[GROUP BY col_list [HAVING condition]]</div>
<div>[&nbsp;&nbsp; CLUSTER BY col_list</div>
<div>&nbsp; | [DISTRIBUTE BY col_list] [SORT BY| ORDER BY col_list]</div>
<div>]</div>
<div>[LIMIT number]</div>
<div>
<div>&bull;使用ALL和DISTINCT选项区分对重复记录的处理。默认是ALL，表示查询所有记录。DISTINCT表示去掉重复的记录</div>
<div>&bull;</div>
<div>&bull;Where 条件</div>
<div>&bull;类似我们传统SQL的where 条件</div>
<div>&bull;目前支持 AND,OR ,0.9版本支持between</div>
<div>&bull;IN, NOT IN</div>
<div>&bull;不支持EXIST ,NOT EXIST</div>
<div>
<div>ORDER BY与SORT BY的不同</div>
<div>
<div>&bull;ORDER BY 全局排序，只有一个Reduce任务</div>
<div>&bull;SORT BY 只在本机做排序</div>
<div>&nbsp;</div>
</div>
<div>Limit</div>
<div>
<div>&bull;Limit 可以限制查询的记录数</div>
<div>SELECT * FROM t1 LIMIT 5</div>
<div>&bull;实现Top k 查询</div>
<div>&bull;下面的查询语句查询销售记录最大的 5 个销售代表。</div>
<div>SET mapred.reduce.tasks = 1&nbsp;<br />&nbsp; SELECT * FROM test SORT BY amount DESC LIMIT 5</div>
<div>&bull;REGEX Column Specification</div>
<div>SELECT 语句可以使用正则表达式做列选择，下面的语句查询除了 ds 和 hr 之外的所有列：</div>
<div>SELECT `(ds|hr)?+.+` FROM test</div>
</div>
</div>
</div>
</div>

<h3>例如</h3>
<h3>按先件查询</h3>
<p>hive&gt; SELECT a.foo FROM invites a WHERE a.ds='&lt;DATE&gt;';</p>
<h3>将查询数据输出至目录：</h3>
<p>hive&gt; INSERT OVERWRITE DIRECTORY '/tmp/hdfs_out' SELECT a.* FROM invites a WHERE a.ds='&lt;DATE&gt;';</p>
<h3>将查询结果输出至本地目录：</h3>
<p>hive&gt; INSERT OVERWRITE LOCAL DIRECTORY '/tmp/local_out' SELECT a.* FROM pokes a;</p>
<h3>选择所有列到本地目录 ：</h3>
<p>hive&gt; INSERT OVERWRITE TABLE events SELECT a.* FROM profiles a;<br />hive&gt; INSERT OVERWRITE TABLE events SELECT a.* FROM profiles a WHERE a.key &lt; 100;<br />hive&gt; INSERT OVERWRITE LOCAL DIRECTORY '/tmp/reg_3' SELECT a.* FROM events a;<br />hive&gt; INSERT OVERWRITE DIRECTORY '/tmp/reg_4' select a.invites, a.pokes FROM profiles a;<br />hive&gt; INSERT OVERWRITE DIRECTORY '/tmp/reg_5' SELECT COUNT(1) FROM invites a WHERE a.ds='&lt;DATE&gt;';<br />hive&gt; INSERT OVERWRITE DIRECTORY '/tmp/reg_5' SELECT a.foo, a.bar FROM invites a;<br />hive&gt; INSERT OVERWRITE LOCAL DIRECTORY '/tmp/sum' SELECT SUM(a.pc) FROM pc1 a;</p>
<h3>将一个表的统计结果插入另一个表中：</h3>
<p>hive&gt; FROM invites a INSERT OVERWRITE TABLE events SELECT a.bar, count(1) WHERE a.foo &gt; 0 GROUP BY a.bar;<br />hive&gt; INSERT OVERWRITE TABLE events SELECT a.bar, count(1) FROM invites a WHERE a.foo &gt; 0 GROUP BY a.bar;<br />JOIN<br />hive&gt; FROM pokes t1 JOIN invites t2 ON (t1.bar = t2.bar) INSERT OVERWRITE TABLE events SELECT t1.bar, t1.foo, t2.foo;</p>
<h3>将多表数据插入到同一表中：</h3>
<p>FROM src<br />INSERT OVERWRITE TABLE dest1 SELECT src.* WHERE src.key &lt; 100<br />INSERT OVERWRITE TABLE dest2 SELECT src.key, src.value WHERE src.key &gt;= 100 and src.key &lt; 200<br />INSERT OVERWRITE TABLE dest3 PARTITION(ds='2008-04-08', hr='12') SELECT src.key WHERE src.key &gt;= 200 and src.key &lt; 300<br />INSERT OVERWRITE LOCAL DIRECTORY '/tmp/dest4.out' SELECT src.value WHERE src.key &gt;= 300;</p>
<h3>将文件流直接插入文件：</h3>
<p>hive&gt; FROM invites a INSERT OVERWRITE TABLE events SELECT TRANSFORM(a.foo, a.bar) AS (oof, rab) USING '/bin/cat' WHERE a.ds &gt; '2008-08-09';<br />This streams the data in the map phase through the script /bin/cat (like hadoop streaming). Similarly - streaming can be used on the reduce side (please see the Hive Tutorial or examples)</p>
<h3>3.2 基于Partition的查询</h3>
<div>
<div>&bull;一般 SELECT 查询会扫描整个表，使用 PARTITIONED BY 子句建表，查询就可以利用分区剪枝（input pruning）的特性</div>
<div>&bull;Hive 当前的实现是，只有分区断言出现在离 FROM 子句最近的那个WHERE 子句中，才会启用分区剪枝</div>
<div>&nbsp;</div>
<div>
<h3>3.3 Join</h3>
<div>
<div>Syntax</div>
<div>join_table:&nbsp;<br />&nbsp;&nbsp; table_reference JOIN table_factor [join_condition]&nbsp;<br />&nbsp; | table_reference {LEFT|RIGHT|FULL} [OUTER] JOIN table_reference join_condition&nbsp;<br />&nbsp; | table_reference LEFT SEMI JOIN table_reference join_condition</p>
<p>table_reference:&nbsp;<br />&nbsp;&nbsp;&nbsp; table_factor&nbsp;<br />&nbsp; | join_table</p>
<p>table_factor:&nbsp;<br />&nbsp;&nbsp;&nbsp; tbl_name [alias]&nbsp;<br />&nbsp; | table_subquery alias&nbsp;<br />&nbsp; | ( table_references )</p>
<p>join_condition:&nbsp;<br />&nbsp;&nbsp;&nbsp; ON equality_expression ( AND equality_expression )*</p>
<p>equality_expression:&nbsp;<br />&nbsp;&nbsp;&nbsp; expression = expression</div>
<div>
<div>
<div>&bull;Hive 只支持等值连接（equality joins）、外连接（outer joins）和（left semi joins）。Hive 不支持所有非等值的连接，因为非等值连接非常难转化到 map/reduce 任务</div>
<div>&nbsp;</div>
<div>&bull;LEFT，RIGHT和FULL OUTER关键字用于处理join中空记录的情况</div>
<div>&bull;LEFT SEMI JOIN 是 IN/EXISTS 子查询的一种更高效的实现</div>
<div>&bull;join 时，每次 map/reduce 任务的逻辑是这样的：reducer 会缓存 join 序列中除了最后一个表的所有表的记录，再通过最后一个表将结果序列化到文件系统</div>
<div>&bull;实践中，应该把最大的那个表写在最后</div>
<div>
<div>join&nbsp;查询时，需要注意几个关键点</div>
<div>
<div>&bull;只支持等值join</div>
<div>&bull;SELECT a.* FROM a JOIN b ON (a.id = b.id)</div>
<div>&bull;SELECT a.* FROM a JOIN b&nbsp;<br />&nbsp;&nbsp;&nbsp; ON (a.id = b.id AND a.department = b.department)</div>
<div>
<div>&bull;可以 join 多于 2 个表，例如</div>
<div>&nbsp; SELECT a.val, b.val, c.val FROM a JOIN b&nbsp;<br />&nbsp;&nbsp;&nbsp; ON (a.key = b.key1) JOIN c ON (c.key = b.key2)</div>
<div>&nbsp;</div>
<div>&bull;如果join中多个表的 join key 是同一个，则 join 会被转化为单个 map/reduce 任务</div>
</div>
</div>
</div>
</div>
</div>
</div>
</div>
</div>
<div>LEFT，RIGHT和FULL OUTER</div>
<div>
<div>&bull;例子</div>
<div>&bull;SELECT a.val, b.val FROM a LEFT OUTER JOIN b ON (a.key=b.key)</div>
<div>&nbsp;</div>
<div>&bull;如果你想限制 join 的输出，应该在 WHERE 子句中写过滤条件&mdash;&mdash;或是在 join 子句中写</div>
<div>&bull;</div>
<div>&bull;容易混淆的问题是表分区的情况</div>
<div>&bull;&nbsp;SELECT c.val, d.val FROM c LEFT OUTER JOIN d ON (c.key=d.key)&nbsp;<br />&nbsp; WHERE a.ds='2010-07-07' AND b.ds='2010-07-07&lsquo;</div>
<div>&bull;如果 d 表中找不到对应 c 表的记录，d 表的所有列都会列出 NULL，包括 ds 列。也就是说，join 会过滤 d 表中不能找到匹配 c 表 join key 的所有记录。这样的话，LEFT OUTER 就使得查询结果与 WHERE 子句无关</div>
<div>&bull;解决办法</div>
<div>&bull;SELECT c.val, d.val FROM c LEFT OUTER JOIN d&nbsp;<br />&nbsp; ON (c.key=d.key AND d.ds='2009-07-07' AND c.ds='2009-07-07')</div>
<div>
<div>LEFT SEMI JOIN</div>
<div>
<div>&bull;LEFT SEMI JOIN 的限制是， JOIN 子句中右边的表只能在 ON 子句中设置过滤条件，在 WHERE 子句、SELECT 子句或其他地方过滤都不行</div>
<div>&bull;</div>
<div>&bull;SELECT a.key, a.value&nbsp;<br />&nbsp; FROM a&nbsp;<br />&nbsp; WHERE a.key in&nbsp;<br />&nbsp;&nbsp; (SELECT b.key&nbsp;<br />&nbsp;&nbsp;&nbsp; FROM B);</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 可以被重写为：</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; SELECT a.key, a.val&nbsp;<br />&nbsp;&nbsp; FROM a LEFT SEMI JOIN b on (a.key = b.key)</div>
<div>
<div>UNION ALL</div>
<div>
<div>&bull;用来合并多个select的查询结果，需要保证select中字段须一致</div>
<div>&bull;select_statement UNION ALL select_statement UNION ALL select_statement ...</div>
</div>
</div>
</div>
</div>
</div>

<p>4. &nbsp;从SQL到HiveQL应转变的习惯</p>
<div>
<h3>1、Hive不支持等值连接</h3>
<div>
<div>&bull;SQL中对两表内联可以写成：</div>
<div>&bull;select * from dual a,dual b where a.key = b.key;</div>
<div>&bull;Hive中应为</div>
<div>&bull;select * from dual a join dual b on a.key = b.key;&nbsp;</div>
<div>而不是传统的格式：</p>
<p>SELECT t1.a1 as c1, t2.b1 as c2FROM t1, t2<br />
 WHERE t1.a2 = t2.b2</p>
</div>
<div>
<h3>2、分号字符</h3>
</div>
</div>
</div>
<div>
<div>&bull;分号是SQL语句结束标记，在HiveQL中也是，但是在HiveQL中，对分号的识别没有那么智慧，例如：</div>
<div>&bull;select concat(key,concat(';',key)) from dual;</div>
<div>&bull;但HiveQL在解析语句时提示：</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; FAILED: Parse Error: line 0:-1 mismatched input '&lt;EOF&gt;' expecting ) in function specification</div>
<div>&bull;解决的办法是，使用分号的八进制的ASCII码进行转义，那么上述语句应写成：</div>
<div>&bull;select concat(key,concat('\073',key)) from dual;</div>
<div>&nbsp;</div>
<div>
<h3>3、IS [NOT] NULL</h3>
<div>
<div>&bull;SQL中null代表空值,&nbsp;值得警惕的是, 在HiveQL中String类型的字段若是空(empty)字符串, 即长度为0, 那么对它进行IS NULL的判断结果是False.</div>
</div>
</div>
</div>
<h3>4、Hive不支持将数据插入现有的表或分区中，</h3>
<p>仅支持覆盖重写整个表，示例如下：</p>
<div>
<ol><li>INSERT&nbsp;OVERWRITE&nbsp;TABLE&nbsp;t1</li>
<li>SELECT&nbsp;*&nbsp;FROM&nbsp;t2;</li></ol>
</div>
<h3>4、hive不支持INSERT INTO, UPDATE, DELETE操作</h3>
</div>
<div>
<p>这样的话，就不要很复杂的锁机制来读写数据。<br />&nbsp; &nbsp; &nbsp;INSERT INTO syntax is only available starting in version 0.8。INSERT INTO就是在表或分区中追加数据。</p>
<h3>5、hive支持嵌入mapreduce程序，来处理复杂的逻辑</h3>
<p>如：</p>
<div>
<ol><li>FROM&nbsp;(</li>
<li>MAP&nbsp;doctext&nbsp;USING&nbsp;'python&nbsp;wc_mapper.py'&nbsp;AS&nbsp;(word,&nbsp;cnt)</li>
<li>FROM&nbsp;docs</li>
<li>CLUSTER&nbsp;BY&nbsp;word</li>
<li>)&nbsp;a</li>
<li>REDUCE&nbsp;word,&nbsp;cnt&nbsp;USING&nbsp;'python&nbsp;wc_reduce.py';</li></ol>
</div>
<p>--doctext: 是输入</p>
<p>--word, cnt: 是map程序的输出</p>
<p>--CLUSTER BY: 将wordhash后，又作为reduce程序的输入</p>
<p>并且map程序、reduce程序可以单独使用，如：</p>
<div>
<ol><li>FROM&nbsp;(</li>
<li>FROM&nbsp;session_table</li>
<li>SELECT&nbsp;sessionid,&nbsp;tstamp,&nbsp;data</li>
<li>DISTRIBUTE&nbsp;BY&nbsp;sessionid&nbsp;SORT&nbsp;BY&nbsp;tstamp</li>
<li>)&nbsp;a</li>
<li>REDUCE&nbsp;sessionid,&nbsp;tstamp,&nbsp;data&nbsp;USING&nbsp;'session_reducer.sh';</li></ol>
</div>
<p>--DISTRIBUTE BY: 用于给reduce程序分配行数据</p>
<h3>6、hive支持将转换后的数据直接写入不同的表，还能写入分区、hdfs和本地目录。</h3>
<p>这样能免除多次扫描输入表的开销。</p>
<div>
<ol><li>FROM&nbsp;t1</li>
<li>INSERT&nbsp;OVERWRITE&nbsp;TABLE&nbsp;t2</li>
<li>SELECT&nbsp;t3.c2,&nbsp;count(1)</li>
<li>FROM&nbsp;t3</li>
<li>WHERE&nbsp;t3.c1&nbsp;&lt;=&nbsp;20</li>
<li>GROUP&nbsp;BY&nbsp;t3.c2</li>
<li>INSERT&nbsp;OVERWRITE&nbsp;DIRECTORY&nbsp;'/output_dir'</li>
<li>SELECT&nbsp;t3.c2,&nbsp;avg(t3.c1)</li>
<li>FROM&nbsp;t3</li>
<li>WHERE&nbsp;t3.c1&nbsp;&gt;&nbsp;20&nbsp;AND&nbsp;t3.c1&nbsp;&lt;=&nbsp;30</li>
<li>GROUP&nbsp;BY&nbsp;t3.c2</li>
<li>INSERT&nbsp;OVERWRITE&nbsp;LOCAL&nbsp;DIRECTORY&nbsp;'/home/dir'</li>
<li>SELECT&nbsp;t3.c2,&nbsp;sum(t3.c1)</li>
<li>FROM&nbsp;t3</li>
<li>WHERE&nbsp;t3.c1&nbsp;&gt;&nbsp;30</li>
<li>GROUP&nbsp;BY&nbsp;t3.c2;</li></ol>
</div>

<p>5. &nbsp;实际示例</p>
<h3>创建一个表</h3>
<p>CREATE TABLE u_data (<br />userid INT,<br />movieid INT,<br />rating INT,<br />unixtime STRING)<br />ROW FORMAT DELIMITED<br />FIELDS TERMINATED BY '/t'<br />STORED AS TEXTFILE;</p>
<p>下载示例数据文件，并解压缩<br />wget&nbsp;<a href="http://www.grouplens.org/system/files/ml-data.tar__0.gz" rel="external nofollow noreferrer">http://www.grouplens.org/system/files/ml-data.tar__0.gz</a><br />tar xvzf ml-data.tar__0.gz</p>
<h3>加载数据到表中:</h3>
<p>LOAD DATA LOCAL INPATH 'ml-data/u.data'<br />OVERWRITE INTO TABLE u_data;</p>
<h3>统计数据总量:</h3>
<p>SELECT COUNT(1) FROM u_data;</p>
<h3>现在做一些复杂的数据分析:</h3>
<p>创建一个 weekday_mapper.py: 文件，作为数据按周进行分割&nbsp;<br />import sys<br />import datetime</p>
<p>for line in sys.stdin:<br />line = line.strip()<br />userid, movieid, rating, unixtime = line.split('/t')</p>
<h3>生成数据的周信息</h3>
<p>weekday = datetime.datetime.fromtimestamp(float(unixtime)).isoweekday()<br />print '/t'.join([userid, movieid, rating, str(weekday)])</p>
<h3>使用映射脚本</h3>
<p>//创建表，按分割符分割行中的字段值<br />CREATE TABLE u_data_new (<br />userid INT,<br />movieid INT,<br />rating INT,<br />weekday INT)<br />ROW FORMAT DELIMITED<br />FIELDS TERMINATED BY '/t';<br />//将python文件加载到系统<br />add FILE weekday_mapper.py;</p>
<h3>将数据按周进行分割</h3>
<p>INSERT OVERWRITE TABLE u_data_new<br />SELECT<br />TRANSFORM (userid, movieid, rating, unixtime)<br />USING 'python weekday_mapper.py'<br />AS (userid, movieid, rating, weekday)<br />FROM u_data;</p>
<p>SELECT weekday, COUNT(1)<br />FROM u_data_new<br />GROUP BY weekday;</p>
<h3>处理Apache Weblog 数据</h3>
<p>将WEB日志先用正则表达式进行组合，再按需要的条件进行组合输入到表中<br />add jar ../build/contrib/hive_contrib.jar;</p>
<p>CREATE TABLE apachelog (<br />host STRING,<br />identity STRING,<br />user STRING,<br />time STRING,<br />request STRING,<br />status STRING,<br />size STRING,<br />referer STRING,<br />agent STRING)<br />ROW FORMAT SERDE 'org.apache.hadoop.hive.contrib.serde2.RegexSerDe'<br />WITH SERDEPROPERTIES (<br />"input.regex" = "([^ ]*) ([^ ]*) ([^ ]*) (-|//[[^//]]*//]) ([^ /"]*|/"[^/"]*/") (-|[0-9]*) (-|[0-9]*)(?: ([^ /"]*|/"[^/"]*/") ([^ /"]*|/"[^/"]*/"))?",<br />"output.format.string" = "%1$s %2$s %3$s %4$s %5$s %6$s %7$s %8$s %9$s"<br />)<br />STORED AS TEXTFILE;</p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4yzyeq.html">django 1&period;10 CSRF验证失败的解决过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/390vwgj8.html">Json在PHP与JS之间传输</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kjng69.html">一种Flash页游前端3D转2D显示技术&mdash;&mdash;PV2D&comma; 颠覆传统吧！</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jpryl9.html">全面分析Java的垃圾回收机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlk7rx8.html">AJAX 的简单用法：</a>
		</li>
						<li><a href="https://www.batexi.com/a/39revwdq.html">02 C语言指针</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1eo538.html">C蛮的全栈之路-序章 技术栈选择与全栈工程师</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp0k539.html">Android创建启动画面</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy14dnmq.html">关于源码编译每次提示有错误 要make update-api</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mel7jpq.html">nmp install 异常</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pvjjy8.html">python2x和python3的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyydj7dq.html">谈谈我对 js原型链的理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlll670q.html">&lbrack;转&rsqb;使用Git Submodule管理子模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o374g8.html">EF 事务&lpar;非分布式事务&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyjnrgq.html">XX-net</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m200m6q.html">pack 方便的npm 构建工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyykp42q.html">xml配置&ast;的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjmnw08.html">一段刚刚出炉的CSV文件转换为DataTable对象的代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnyd24q.html">容器集成平台 rancher部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwl0z4l9.html">文件的存储GridFS</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/5qyy3jgq.html">Cesium应用篇：3控件（6） FullScreen&sol; VR &sol; Home</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqll3g1q.html">网页开发中文本编辑器UEditor的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwvm7z8.html">SpringBoot整合MyBatis</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwv2vy8.html">&lbrack;Nancy On &period;Net Core Docker&rsqb; 轻量级的web框架</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4j0p3q.html">shell调用函数返回值深入分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kj7y59.html">FreeRTOS 中断优先级嵌套错误引发HardFault异常解决（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o17vxq.html">MVC 自定义Htmlhelper扩展</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv2xg19.html">win10下装Ubuntu双系统</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv2g1z9.html">spring Mvc &plus; Mybatis 中使用junit</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9ppjry9.html">取出session中的所有属性与值的方法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
